=== modified file 'drizzled/drizzled.cc'
--- drizzled/drizzled.cc	2008-12-24 18:50:40 +0000
+++ drizzled/drizzled.cc	2008-12-30 01:43:46 +0000
@@ -3383,12 +3383,6 @@
    (char**) &max_system_variables.myisam_max_sort_file_size, 0,
    GET_ULL, REQUIRED_ARG, (int64_t) LONG_MAX, 0, (uint64_t) MAX_FILE_SIZE,
    0, 1024*1024, 0},
-  {"myisam_repair_threads", OPT_MYISAM_REPAIR_THREADS,
-   N_("Number of threads to use when repairing MyISAM tables. The value of "
-      "1 disables parallel repair."),
-   (char**) &global_system_variables.myisam_repair_threads,
-   (char**) &max_system_variables.myisam_repair_threads, 0,
-   GET_ULONG, REQUIRED_ARG, 1, 1, ULONG_MAX, 0, 1, 0},
   {"myisam_sort_buffer_size", OPT_MYISAM_SORT_BUFFER_SIZE,
    N_("The buffer that is allocated when sorting the index when doing a "
       "REPAIR or when creating indexes with CREATE INDEX or ALTER TABLE."),

=== modified file 'drizzled/session.h'
--- drizzled/session.h	2008-12-24 02:06:33 +0000
+++ drizzled/session.h	2008-12-30 01:43:46 +0000
@@ -162,7 +162,6 @@
   uint64_t max_sort_length;
   uint64_t max_tmp_tables;
   uint64_t min_examined_row_limit;
-  uint32_t myisam_repair_threads;
   size_t myisam_sort_buff_size;
   uint32_t myisam_stats_method;
   uint32_t net_buffer_length;

=== modified file 'drizzled/set_var.cc'
--- drizzled/set_var.cc	2008-12-24 02:06:33 +0000
+++ drizzled/set_var.cc	2008-12-30 01:43:46 +0000
@@ -242,7 +242,6 @@
 static sys_var_session_uint64_t sys_min_examined_row_limit(&vars, "min_examined_row_limit",
                                                            &SV::min_examined_row_limit);
 static sys_var_session_uint64_t	sys_myisam_max_sort_file_size(&vars, "myisam_max_sort_file_size", &SV::myisam_max_sort_file_size, fix_myisam_max_sort_file_size, 1);
-static sys_var_session_uint32_t       sys_myisam_repair_threads(&vars, "myisam_repair_threads", &SV::myisam_repair_threads);
 static sys_var_session_size_t	sys_myisam_sort_buffer_size(&vars, "myisam_sort_buffer_size", &SV::myisam_sort_buff_size);
 
 static sys_var_session_enum         sys_myisam_stats_method(&vars, "myisam_stats_method",

=== modified file 'storage/myisam/ha_myisam.cc'
--- storage/myisam/ha_myisam.cc	2008-12-20 23:44:07 +0000
+++ storage/myisam/ha_myisam.cc	2008-12-30 01:43:46 +0000
@@ -31,6 +31,8 @@
 ulong myisam_recover_options= HA_RECOVER_NONE;
 pthread_mutex_t THR_LOCK_myisam= PTHREAD_MUTEX_INITIALIZER;
 
+static uint32_t repair_threads;
+
 /* bits in myisam_recover_options */
 const char *myisam_recover_names[] =
 { "DEFAULT", "BACKUP", "FORCE", "QUICK", NULL};
@@ -875,7 +877,7 @@
       local_testflag|= T_STATISTICS;
       param.testflag|= T_STATISTICS;		// We get this for free
       statistics_done=1;
-      if (session->variables.myisam_repair_threads>1)
+      if (repair_threads > 1)
       {
         char buf[40];
         /* TODO: respect myisam_repair_threads variable */
@@ -1859,6 +1861,17 @@
   return NULL;
 }
 
+static DRIZZLE_SYSVAR_UINT(repair_threads, repair_threads,
+  PLUGIN_VAR_RQCMDARG,
+  N_("Number of threads to use when repairing MyISAM tables. The value of "
+     "1 disables parallel repair."),
+  NULL, NULL, 1, 1, UINT32_MAX, 0);
+
+static struct st_mysql_sys_var* system_variables[]= {
+  DRIZZLE_SYSVAR(repair_threads),
+  NULL
+};
+
 
 mysql_declare_plugin(myisam)
 {
@@ -1871,7 +1884,7 @@
   myisam_init, /* Plugin Init */
   myisam_deinit, /* Plugin Deinit */
   NULL,                       /* status variables                */
-  NULL,                       /* system variables                */
+  system_variables,           /* system variables */
   NULL                        /* config options                  */
 }
 mysql_declare_plugin_end;

=== modified file 'tests/r/repair.result'
--- tests/r/repair.result	2008-12-22 01:55:43 +0000
+++ tests/r/repair.result	2008-12-30 01:43:46 +0000
@@ -41,14 +41,14 @@
 drop table t1;
 CREATE TABLE t1(a INT, KEY(a)) ENGINE=MyISAM;
 INSERT INTO t1 VALUES(1),(2),(3),(4),(5);
-SET myisam_repair_threads=2;
+SET GLOBAL myisam_repair_threads=2;
 REPAIR TABLE t1;
 Table	Op	Msg_type	Msg_text
 test.t1	repair	status	OK
 SHOW INDEX FROM t1;
 Table	Non_unique	Key_name	Seq_in_index	Column_name	Collation	Cardinality	Sub_part	Packed	Null	Index_type	Comment	Index_Comment
 t1	1	a	1	a	A	5	NULL	NULL	YES	BTREE		
-SET myisam_repair_threads=@@global.myisam_repair_threads;
+SET GLOBAL myisam_repair_threads=1;
 DROP TABLE t1;
 CREATE TABLE t1(a INT) ENGINE=MyISAM;
 USE mysql;
@@ -77,13 +77,13 @@
 ('0'),('0'),('0'),('0'),('0'),('0'),('0'),('0'),('0'),('0'),
 ('0'),('0'),('0'),('0'),('0'),('0'),('0');
 ERROR HY000: myisam_sort_buffer_size is too small
-SET myisam_repair_threads=2;
+SET GLOBAL myisam_repair_threads=2;
 REPAIR TABLE t1;
 Table	Op	Msg_type	Msg_text
 test.t1	repair	error	myisam_sort_buffer_size is too small
 test.t1	repair	warning	Number of rows changed from 0 to 157
 test.t1	repair	status	OK
-SET myisam_repair_threads=@@global.myisam_repair_threads;
+SET GLOBAL myisam_repair_threads=1;
 SET myisam_sort_buffer_size=@@global.myisam_sort_buffer_size;
 DROP TABLE t1;
 CREATE TABLE t1(a CHAR(255), KEY(a)) ENGINE=MyISAM;
@@ -105,11 +105,11 @@
 ('0'),('0'),('0'),('0'),('0'),('0'),('0'),('0'),('0'),('0'),
 ('0'),('0'),('0'),('0'),('0'),('0'),('0'),('0'),('0'),('0'),
 ('0'),('0'),('0'),('0'),('0'),('0'),('0');
-SET myisam_repair_threads=2;
+SET GLOBAL myisam_repair_threads=2;
 REPAIR TABLE t1;
 Table	Op	Msg_type	Msg_text
 test.t1	repair	status	OK
-SET myisam_repair_threads=@@global.myisam_repair_threads;
+SET GLOBAL myisam_repair_threads=1;
 SET myisam_sort_buffer_size=@@global.myisam_sort_buffer_size;
 DROP TABLE t1;
 End of 4.1 tests

=== modified file 'tests/t/repair.test'
--- tests/t/repair.test	2008-12-22 01:55:43 +0000
+++ tests/t/repair.test	2008-12-30 01:43:46 +0000
@@ -41,10 +41,10 @@
 #
 CREATE TABLE t1(a INT, KEY(a)) ENGINE=MyISAM;
 INSERT INTO t1 VALUES(1),(2),(3),(4),(5);
-SET myisam_repair_threads=2;
+SET GLOBAL myisam_repair_threads=2;
 REPAIR TABLE t1;
 SHOW INDEX FROM t1;
-SET myisam_repair_threads=@@global.myisam_repair_threads;
+SET GLOBAL myisam_repair_threads=1;
 DROP TABLE t1;
 
 #
@@ -81,9 +81,9 @@
 ('0'),('0'),('0'),('0'),('0'),('0'),('0'),('0'),('0'),('0'),
 ('0'),('0'),('0'),('0'),('0'),('0'),('0'),('0'),('0'),('0'),
 ('0'),('0'),('0'),('0'),('0'),('0'),('0');
-SET myisam_repair_threads=2;
+SET GLOBAL myisam_repair_threads=2;
 REPAIR TABLE t1;
-SET myisam_repair_threads=@@global.myisam_repair_threads;
+SET GLOBAL myisam_repair_threads=1;
 SET myisam_sort_buffer_size=@@global.myisam_sort_buffer_size;
 DROP TABLE t1;
 
@@ -110,9 +110,9 @@
 ('0'),('0'),('0'),('0'),('0'),('0'),('0'),('0'),('0'),('0'),
 ('0'),('0'),('0'),('0'),('0'),('0'),('0'),('0'),('0'),('0'),
 ('0'),('0'),('0'),('0'),('0'),('0'),('0');
-SET myisam_repair_threads=2;
+SET GLOBAL myisam_repair_threads=2;
 REPAIR TABLE t1;
-SET myisam_repair_threads=@@global.myisam_repair_threads;
+SET GLOBAL myisam_repair_threads=1;
 SET myisam_sort_buffer_size=@@global.myisam_sort_buffer_size;
 DROP TABLE t1;
 

